#include"MotorKlasse.h"
#include"SensorKlasse.h"
#include <SimpleList.h>
#include <Servo.h>

//Pins des Farbsensors
//#define S2 7
//#define S3 2
//#define sensorOUT 8

Motor rechterMotor;
Motor linkerMotor;

Sensor sensorVorneUntenRechts;
Sensor sensorVorneUntenLinks;
Sensor sensorHintenUnten;
Sensor sensorVorne;
Sensor sensorHinten;

Servo servo;   //Servo für den Sensor sensorVorne

int motorenDelay = 3;
int counter = 0;
int gradServo = 30;

SimpleList<char>* weg = new SimpleList<char>();
int theSize = weg->size();

//Stütze berechnen Farbe
float SummenRWert = 0;
float SummenGWert = 0;
float SummenBWert = 0;
float SummenCWert = 0;

void setup() {
  Serial.begin(9600);

  rechterMotor.setup(3, 4);
  linkerMotor.setup(5, 6);

  sensorVorneUntenRechts.setup(7, 8);

  //sensorVorneUntenRechts.setup(A6, A0);
  sensorVorneUntenLinks.setup(A4, A5);
  sensorHintenUnten.setup(9, 10);
  sensorVorne.setup(A2, A3);
  sensorHinten.setup(11, 12);

  servo.attach(A1);

  //für den Farbsensor
  //pinMode(S2, OUTPUT);
  //pinMode(S3, OUTPUT);
}


void loop() {
  int abstandVorneUntenRechts = sensorVorneUntenRechts.abstandMessen();
  int abstandVorneUntenLinks = sensorVorneUntenLinks.abstandMessen();
  int abstandHintenUnten = sensorHintenUnten.abstandMessen();
  int abstandVorne = sensorVorne.abstandMessen();
  int abstandHinten = sensorHinten.abstandMessen();


  /*farbe();
    float durchschnittsWerte[4] = {SummenRWert / 50, SummenGWert / 50, SummenBWert / 50, SummenCWert / 50};


    welcheFarbe(durchschnittsWerte);

    /*Serial.println(durchschnittsWerte[0]);
    Serial.println(durchschnittsWerte[1]);
    Serial.println(durchschnittsWerte[2]);
    Serial.println(durchschnittsWerte[3]);*/


  /*Serial.println(abstandVorneUntenLinks);
    Serial.println(abstandHintenUnten);
    Serial.println(abstandVorne);
    Serial.println(abstandHinten);*/


  int grad = objektFinden();
    zuObjektDrehen(grad);
    fahreZuObjekt();
    vonObjektEntfernen();
    drivebwdl(150);
    
}


void drivefwd() {
  // Fahre vorwärts
  rechterMotor.drivefwd(motorenDelay);
  linkerMotor.drivefwd(motorenDelay);
  counter++;
  if (counter == 3) {
    rechterMotor.drivefwd(motorenDelay);
    rechterMotor.drivefwd(motorenDelay);
    counter = 0;
  }
  weg->add('f');
}


void drivebwd() {
  // Fahre rückwärts
  rechterMotor.drivebwd(motorenDelay);
  linkerMotor.drivebwd(motorenDelay);
  counter++;
  if (counter == 3) {
    rechterMotor.drivebwd(motorenDelay);
    rechterMotor.drivebwd(motorenDelay);
    counter = 0;
  }
  weg->add('b');
}


/*void drivefwdl() {
  //fahre nach vorne rechts
  rechterMotor.drivefwd(motorenDelay);
  linkerMotor.drivebwd(motorenDelay);
  rechterMotor.drivefwd(motorenDelay);
  }


  void drivefwdr() {
  //fahre nach vorne links
  rechterMotor.drivebwd(motorenDelay);
  linkerMotor.drivefwd(motorenDelay);
  }*/


void drivebwdl(int val) {
  //fahre nach hinten links
  for (int i = 0; i < val; i++) {
    rechterMotor.drivebwd(motorenDelay);
    linkerMotor.drivefwd(motorenDelay);
    rechterMotor.drivebwd(motorenDelay);

    weg->add('l');
  }
}


void drivebwdr(int val) {
  //fahre nach hinten rechts
  for (int i = 0; i < val; i++) {
    linkerMotor.drivebwd(motorenDelay);
    rechterMotor.drivefwd(motorenDelay);

    weg->add('r');
  }
}


int objektFinden() {
  int  abstandVorne = 200;
  int grad = 30;
  for (int i = 40; i <= 115; i++) {
    servo.write(i);
    int abstandVorneNeu = sensorVorne.abstandMessen();
    if ((abstandVorneNeu < abstandVorne) && (abstandVorneNeu > 10)) {
      abstandVorne = abstandVorneNeu;
      grad = i;
    }
    delay(100);
  }
  servo.write(grad);
  return grad;
}


void zuObjektDrehen(int grad) {
  if (grad > 72) {
    drivebwdl((grad - 72) * 2);
  } else {
    drivebwdr((72 - grad) * 2);
  }
  delay(1500);
}


void fahreZuObjekt() {
  int abstandVorne = sensorVorne.abstandMessen();
  int tod = abgrund();
  servo.write(72);
  do {
    abstandVorne = sensorVorne.abstandMessen();
    tod = abgrund();
    drivefwd();
  } while ((abstandVorne > 8) && (tod == 0));
  delay(3000);
}


void vonObjektEntfernen() {
  int abstandHintenUnten = sensorHintenUnten.abstandMessen();
  int abstandHinten = sensorHinten.abstandMessen();
  for (int i = 0; i < 207; i++) {
    if ((abstandHintenUnten < 10) && (abstandHinten > 10)) {
      drivebwd();
      abstandHintenUnten = sensorHintenUnten.abstandMessen();
      abstandHinten = sensorHinten.abstandMessen();
    } else {
      break;
    }
  }
  delay(1500);
}


int abgrund() {
  int abstandVorneUntenLinks = sensorVorneUntenLinks.abstandMessen();
  int abstandVorneUntenRechts = sensorVorneUntenRechts.abstandMessen();
  int abstandHintenUnten = sensorHintenUnten.abstandMessen();
  Serial.println(abstandVorneUntenLinks);
  Serial.println(abstandVorneUntenRechts);
  Serial.println(abstandHintenUnten);
  if ((abstandVorneUntenLinks < 10) && (abstandVorneUntenRechts < 10) && (abstandHintenUnten < 10)) {
    return 0; //kein abgrund
  } else {
    return 1; //abgrund ist da
  }
}

/*
int sensorRead (int channel) {
  if (channel == 0 || channel == 2) {
    digitalWrite(S2, LOW);
  }
  else {
    digitalWrite(S2, HIGH);
  }

  if (channel == 0 || channel == 3) {
    digitalWrite(S3, LOW);
  }
  else {
    digitalWrite(S3, HIGH);
  }

  int valueSensor = pulseIn(sensorOUT, LOW);
  return valueSensor;
}


float farbe() {
  //Werte zum Umrechnen, für den Farbsensor
  int R_WHITE = 26;
  int R_BLACK = 129;
  int G_WHITE = 38;
  int G_BLACK = 159;
  int B_WHITE = 13;
  int B_BLACK = 48;
  int C_WHITE = 32;
  int C_BLACK = 128;

  SummenRWert = 0;
  SummenGWert = 0;
  SummenBWert = 0;
  SummenCWert = 0;

  for (int i = 0; i < 50; i++) {
    int rWert = map(sensorRead(0), R_BLACK, R_WHITE, 0, 255);
    int gWert = map(sensorRead(1), G_BLACK, G_WHITE, 0, 255);
    int bWert = map(sensorRead(2), B_BLACK, B_WHITE, 0, 255);
    int cWert = map(sensorRead(3), C_BLACK, C_WHITE, 0, 255);
    delay(10);

    SummenRWert += rWert;
    SummenGWert += gWert;
    SummenBWert += bWert;
    SummenCWert += cWert;
  }
}

void welcheFarbe(float durchschnittsWerte[]) {
  if ((durchschnittsWerte[0] > 145) && (durchschnittsWerte[2] > 75)) {
    Serial.println("Ich stehe vor einem roten Objekt, wuuuh!");
  } else if ((durchschnittsWerte[0] < 140) && (durchschnittsWerte[3] > 150)) {
    Serial.println("grün");
  } else if ((durchschnittsWerte[0] < 130) && (durchschnittsWerte[3] < 150)) {
    Serial.println("blau");
  } else {
    Serial.println("ACHTUNG KEINE FARBERKENNUNG");
  }
}*/
